---

- name: Install required system dependencies
  ansible.builtin.apt:
    name: "{{ item }}"
    update_cache: true
  loop: "{{ docker_dependencies }}"
  register: result
  until: result is succeeded

- name: Add docker GPG apt key
  ansible.builtin.apt_key:
    url: "{{ docker_gpg_url }}"
    state: present

- name: Add docker repository
  ansible.builtin.apt_repository:
    repo: "{{ docker_repo }}"
    state: present

- name: "Install docker-{{ docker_edition }}"
  ansible.builtin.apt:
    name: "{{ item }}"
    update_cache: true
    state: "{{ docker_packages_state }}"
  loop: "{{ docker_packages }}"
  register: result
  until: result is succeeded
  notify: Restart docker

- name: Instal docker-compose pip-version
  when: docker_compose_pip_vesion
  block:
    - name: Install pip
      ansible.builtin.apt:
        name:
          - python3-pip
        state: present

    - name: Install docker-compose
      ansible.builtin.pip:
        name: "{{ item }}"
        state: present
      loop:
        - docker
        - docker-compose

- name: Instal docker-compose non python version
  when: not docker_compose_pip_vesion
  block:
    - name: Copy docker-compose plugin
      ansible.builtin.get_url:
        url: "{{ docker_compose_url }}"
        dest: "{{ docker_compose_path }}"
        mode: 0755
      when: docker_compose_install
      notify: Restart docker

    - name: Create symlink for docker-compose
      ansible.builtin.file:
        src: "{{ docker_compose_path }}"
        dest: /usr/bin/docker-compose
        owner: root
        group: root
        state: link

- name: Ensure docker is started and enabled at boot
  ansible.builtin.service:
    name: docker
    state: started
    enabled: true

- name: Ensure docker users are added to the docker group
  ansible.builtin.user:
    name: "{{ item }}"
    groups: docker
    append: true
  with_items: "{{ docker_users }}"
